<template>
		<el-dialog
			width="30%"
			title="Add New Account"
			:visible="dialogFormvisible"
			append-to-body
			@close="$emit('update:dialogFormvisible', false)">
			<el-form id="add-form" @keyup.enter.native="submitForm('content')" :model="content" :rules="rules" ref="content" label-width="120px" class="demo-content-account form-add-account" v-loading="loading"
            >
                <el-form-item class="" prop="name" label="Name" >
					<el-input ref="name" @keyup.enter.native="loseFocus('name')" type="text" placeholder="Enter your name"  v-model="content.name"></el-input>
				</el-form-item>
                <el-form-item class="" prop="username" label="Email" >
					<el-input @keyup.enter.native="loseFocus('email')" type="email" placeholder="Enter your email" v-model="content.username"></el-input>
				</el-form-item>
				<el-form-item label="User Role" prop="selectedRole">
					<el-select v-model="content.selectedRole" placeholder="Select user role">
						<el-option v-for="item in roleList"
								   :label="item.name"
                                   :key="item.id"
								   :value="item.id">
						</el-option>
					</el-select>
				</el-form-item>
				<el-form-item class="" prop="password" label="Password" >
					<el-input ref="password" @keyup.enter.native="loseFocus('password')" type="password" placeholder="Enter your password"  v-model="content.password"></el-input>
				</el-form-item>
				<el-form-item label="Confirm" prop="checkPass">
					<el-input ref="checkPass" @keyup.enter.native="loseFocus('checkPass')" type="password" placeholder="Confirm your password"  v-model="content.checkPass"></el-input>
				</el-form-item>

				<div style="text-align: right; margin-top: 30px;">
					<el-button type="primary" @click="submitForm('content')" :disabled="loading" icon="mdi mdi-plus">Add</el-button>
				</div>
			</el-form>
		</el-dialog>
</template>

<script>
    import $ from 'jquery'
    import {
        account as accountAPI,
        role as roleAPI
    } from '~/services/apis/index';
    import {permission as permissionAPI} from '~/services/apis/index';
    export default {
		name: 'AddAccount',
		props: [ 'dialogFormvisible'],

		data() {
            let validatePass = (rule, value, callback) => {
                if (value === '') {
                callback(new Error('Please input the password'));
                } else if(value.length < 6) {
                callback(new Error('The password must be greater than 6 character'));
                }
                 else {
                if (this.content.checkPass !== '') {
                    this.$refs.content.validateField('checkPass');
                }
                callback();
                }
            };
            let validatePass2 = (rule, value, callback) => {
                if (value === '') {
                callback(new Error('Please confirm password again'));
                } else if(value.length < 6) {
                callback(new Error('The password must be greater than 6 character'));
                }
                 else if (value !== this.content.password) {
                callback(new Error("Confirmed password didn't match!"));
                } else {
                callback();
                }
            };
			return {
                fileList: [

				],
                content: {
                    name: '',
                    username:'',
                    password: '',
                    checkPass: '',
                    selectedRole: "",
                },
                rules: {
                    name: [
                        { required: true, message: 'Please input name', trigger: 'blur' },
                        { max: 255, message: 'Length must be less than 256', trigger: 'blur' }
                    ],
                    username: [
                        { required: true, message: 'Please input email', trigger: 'blur' },
                        { type: 'email', message: 'Invalid email', trigger: 'blur'},
                        { max: 255, message: 'Length must be less than 256', trigger: 'blur' },
                    ],
                    password: [
                            {required: true, validator: validatePass, trigger: 'blur' }
                        ],
                    checkPass: [
                         {required: true, validator: validatePass2, trigger: 'blur' }
                    ],
                    selectedRole: [
                         {required: true, message: 'Please select a role', trigger: 'blur' }
                    ],
                },
                loading: false,
                imageUrl: '',
				imageName: "",
				file: null,
				roleList: [],
			}
		},
		methods: {
            loseFocus(inputName) {
                this.$refs[inputName].blur();
            },
            submitForm(formName) {
                if(!this.$refs[formName]) return false;
                this.$refs[formName].validate((valid) => {
                    if (valid) {
                        this.loading = true;
						this.submit();
                    } else {
                        this.loading = false;
                        return false;
                    }
                });
            },
            resetForm(formName) {
                if(!this.$refs[formName]) return;
                this.$refs[formName].resetFields();

                this.removeImg();
            },

            onRemoveImg(e){
                e.preventDefault();
                e.stopPropagation();
                this.removeImg();
            },
            removeImg(){
                this.imageUrl = "";
                this.imageName = "";
                this.file = null;
            },
			 submit(){

                let data = {
					name: this.content.name,
					username: this.content.username,
					password: this.content.password
                };

                 this.content.selectedRole? data.role_id = this.content.selectedRole : "";

                accountAPI.createAccount(data)
                    .then((res)=>{
                        this.$notify({
                            title: "Success",
                            message: "Add new account successfully!",
                            type: "success"
                        });
                        this.loading = false;
                        this.resetDialog();
                        this.$emit('update:dialogFormvisible', false);
                        this.$parent.getListData();
                    })
                    .catch((err)=>{
                        this.$notify({
                            title: "Error",
                            message: "Add failed!",
                            type: "error"
                        });
                        this.loading = false;
                    })
            },
			// create(iconUrl = ""){
            //     categoryAPI.addCategory(this.content.name, iconUrl)
			// 	.then((res)=>{
            //         this.$parent.getListData();
			// 		this.loading = false;
            //         this.$notify({
            //             title: 'Success',
            //             message: 'Create category successfully!',
            //             type: 'success'
            //         });
            //         this.$emit('update:dialogFormvisible', false);
			// 	})
			// 	.catch((err)=>{
            //         this.loading = false;
            //         this.$notify.error({
            //             title: 'Error',
            //             message: 'Cannot create category'
            //         });
            //         this.$emit('update:dialogFormvisible', false);
			// 	})
			// },
            // onChangeIcon(file, fileList){
            //     if(!file) return;
            //     this.imageName = file.name;
            //     this.imageUrl = URL.createObjectURL(file.raw);
            //     this.file = file.raw;
			// },
			resetDialog(){
                this.resetForm("content");
			},
			getRoleList(){
                roleAPI.getRoles()
					.then((res)=>{
					    this.roleList = res.data.data;

					})
			}


		},
		mounted(){
		    var that = this;
            $('body').on("submit", "#add-form", function(e){
                event.preventDefault();
                that.submitForm('content');
            });
            this.getRoleList();

		},
		watch: {
            //  reset form everytime form changed
            // dialogFormvisible: function () {
            //     this.resetDialog();
            // }
		}

	}
</script>

<style lang="scss">
@import '../../assets/scss/_variables';
	.item-full-width .el-form-item__content{
		margin-left: 0!important;
	}
	.el-dialog__body {
		form{
			margin-top: 10px;
		}
	}

	.upload-img-outer{
		position: relative;
		.icon-img-close{
			position: absolute;
			top: 3px;
			right: 5px;
			padding: 3px;
			&:hover{
			}
		}
	}
	.demo-content-account {
		align-items: right;
	}
	.form-add-account{
		.el-select{
			width: 100%;
		}
	}
</style>
